import java.util.*;

interface Observer {
  public void update();
}

public class Observable {
  private ArrayList observers = new ArrayList();

  public void attach(Observer o) {
    observers.add(o);
  }

  public void detach(Observer o) {
    observers.remove(o);
  }

  public void notify() {
    for(Iterator i = observers.iterator(); i.hasNext(); ) {
      Observer o = (Observer)i.next();
      o.update();
    }
  }
}

class Table extends Observable {
  private int[][] values = {{ 1, 2, 3 }, { 4, 5, 6}};

  public void setValueAt(int i, int j, int val) {
    values[i][j] = val;
  }

  public int getValueAt(int i, int j) {
    return values[i][j];
  }
}

class PieChartView implements Observer {
  private Table table;

  PieChartView(Table table) {
    this.table = table;
    table.attach(this);
  }

  public void update() {
    // get all values and draw them as a pie chart
    //.. table.getValueAt( i, j);
  }
}

class TableView implements Observer {
  private Table table;

  TableView(Table table) {
    this.table = table;
    table.attach(this);
  }

  public void update() {
    // get all values and draw them as a table
    //.. table.getValueAt( i, j);
  }
}
